function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
/* eslint-disable no-plusplus */

import Mark from "./Mark";
var MAX_COUNT = 1000;
var Searcher = /*#__PURE__*/function () {
  function Searcher() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {
      markClassName: 'terminal-viewer-hl-mark',
      markedClassName: 'terminal-viewer-hl-mark terminal-viewer-hl-marked'
    };
    _classCallCheck(this, Searcher);
    _defineProperty(this, "options", void 0);
    this.options = options;
  }
  _createClass(Searcher, [{
    key: "search",
    value: function search(keyword, logs) {
      var _options$decorations, _options$decorations2, _options$decorations3, _options$decorations4, _options$decorations5;
      var hlIndex = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 0;
      var options = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : undefined;
      if (!Array.isArray(logs) || logs.length === 0 || !keyword) {
        return {
          count: 0,
          map: {},
          markedKey: 0
        };
      }
      var _this$options = this.options,
        markClassName = _this$options.markClassName,
        markedClassName = _this$options.markedClassName;
      var style = {
        color: options === null || options === void 0 || (_options$decorations = options.decorations) === null || _options$decorations === void 0 ? void 0 : _options$decorations.matchForegroundColor,
        background: options === null || options === void 0 || (_options$decorations2 = options.decorations) === null || _options$decorations2 === void 0 ? void 0 : _options$decorations2.matchBackground,
        border: options === null || options === void 0 || (_options$decorations3 = options.decorations) === null || _options$decorations3 === void 0 ? void 0 : _options$decorations3.matchBorder
      };
      var markedStyle = {
        background: options === null || options === void 0 || (_options$decorations4 = options.decorations) === null || _options$decorations4 === void 0 ? void 0 : _options$decorations4.activeMatchBackground,
        border: options === null || options === void 0 || (_options$decorations5 = options.decorations) === null || _options$decorations5 === void 0 ? void 0 : _options$decorations5.activeMatchBorder
      };
      var count = 0;
      var markedId = 0;
      var map = {};
      for (var i = 0, len = logs.length; i < len; i++) {
        if (count >= MAX_COUNT) {
          break;
        }
        var text = logs[i] || '';
        if (!text.toLowerCase().includes(keyword.toLowerCase())) {
          // eslint-disable-next-line no-continue
          continue;
        }
        var mark = new Mark(text, {
          className: markClassName,
          markedClassName: markedClassName,
          style: style,
          markedStyle: markedStyle
        });
        var markedText = mark.mark(keyword, {
          matchedIndex: count,
          hlIndex: hlIndex
        }).toString();
        if (mark.isMarked) {
          markedId = i;
        }
        if (mark.matchCount !== 0) {
          count += mark.matchCount;
          map[i] = markedText || text;
        }
        mark.distory();
        mark = null;
      }
      return {
        count: count,
        map: map,
        markedKey: markedId
      };
    }
  }]);
  return Searcher;
}();
export { Searcher as default };