import { useRef, useCallback, useEffect } from 'react';
import throttle from 'lodash.throttle';
var useThrottle = function useThrottle(cb) {
  var delay = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 1000;
  var cbRef = useRef(cb);
  useEffect(function () {
    cbRef.current = cb;
  });
  return useCallback(function () {
    return throttle(cbRef.current, delay)();
  }, [delay]);
};
export default useThrottle;