function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import React, { forwardRef, useCallback, useState, useImperativeHandle, useRef, useEffect, useMemo } from 'react';
import { createPortal } from 'react-dom';
import useDebounceInput from "../Hooks/useDebounceInput";
import TerminalViewerHeader from "../TerminalViewerHeader";
import TerminalViewerBody from "../TerminalViewerBody";
import TerminalViewerVirtualDom from "../TerminalViewerVirtualDom";
import TerminalViewerToolBar from "../TerminalViewerToolBar";
import globalContext from "../Addon/WorkerLog/GlobalContext";
import "./index.less";
var defaultSearchOptions = {
  regex: false,
  wholeWord: false,
  caseSensitive: false,
  incremental: false,
  decorations: {
    matchForegroundColor: '#000000',
    matchBackground: '#ffff54',
    matchBorder: 'none',
    matchOverviewRuler: 'none',
    activeMatchBackground: '#ff9540',
    activeMatchBorder: 'none',
    activeMatchColorOverviewRuler: 'none'
  }
};

// eslint-disable-next-line react/display-name
var TerminalViewer = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var fit = _ref.fit,
    autoScroll = _ref.autoScroll,
    scrollToRow = _ref.scrollToRow,
    refreshable = _ref.refreshable,
    searchPlaceholder = _ref.searchPlaceholder,
    header = _ref.header,
    inputAddonBefore = _ref.inputAddonBefore,
    inputAddonAfter = _ref.inputAddonAfter,
    empty = _ref.empty,
    icons = _ref.icons,
    toolbar = _ref.toolbar,
    showFullScreen = _ref.showFullScreen,
    className = _ref.className,
    style = _ref.style,
    defaultFullScreen = _ref.defaultFullScreen,
    defaultData = _ref.defaultData,
    defaultTabIndex = _ref.defaultTabIndex,
    activeTabIndexProp = _ref.activeTabIndex,
    logAfter = _ref.logAfter,
    tabs = _ref.tabs,
    webLinksSupport = _ref.webLinksSupport,
    canvasSupport = _ref.canvasSupport,
    virtualDomSupport = _ref.virtualDomSupport,
    workerPath = _ref.workerPath,
    remoteOptions = _ref.remoteOptions,
    cacheOptions = _ref.cacheOptions,
    searchOptions = _ref.searchOptions,
    highlightOptions = _ref.highlightOptions,
    terminalOptions = _ref.terminalOptions,
    extraOptions = _ref.extraOptions,
    getContainer = _ref.getContainer,
    onTitleChange = _ref.onTitleChange,
    onLoading = _ref.onLoading,
    onRefresh = _ref.onRefresh;
  var localSearchOptions = searchOptions !== null && searchOptions !== void 0 ? searchOptions : {};
  var instanceRef = useRef();
  var searchValueRef = useRef('');
  var _useState = useState(false),
    _useState2 = _slicedToArray(_useState, 2),
    loading = _useState2[0],
    setLoading = _useState2[1];
  var _useState3 = useState(defaultFullScreen),
    _useState4 = _slicedToArray(_useState3, 2),
    fullScreen = _useState4[0],
    setFullScreen = _useState4[1];
  var _useState5 = useState(activeTabIndexProp || defaultTabIndex || 0),
    _useState6 = _slicedToArray(_useState5, 2),
    activeTabIndex = _useState6[0],
    setActiveTabIndex = _useState6[1];
  var _useState7 = useState({
      resultIndex: -1,
      resultCount: 0
    }),
    _useState8 = _slicedToArray(_useState7, 2),
    searchResult = _useState8[0],
    setSearchResult = _useState8[1];
  var searchOptionsRef = useRef(_objectSpread(_objectSpread({}, defaultSearchOptions), localSearchOptions));
  useEffect(function () {
    searchOptionsRef.current = _objectSpread(_objectSpread({}, defaultSearchOptions), localSearchOptions);
  });
  var cln = ['terminal-viewer', fullScreen && 'terminal-viewer--fullscreen', className].filter(Boolean).join(' ');
  var ViewerBody = virtualDomSupport ? TerminalViewerVirtualDom : TerminalViewerBody;
  var titles = useMemo(function () {
    if (!Array.isArray(tabs)) {
      return [];
    }
    return tabs.map(function (tab, index) {
      return tab.title || index;
    });
  }, [tabs]);
  var getQueryElement = useCallback(function (query) {
    if (typeof query === 'string') {
      return document.querySelector(query);
    }
    if (typeof query === 'function') {
      return query();
    }
    return query;
  }, []);
  var mountElement = fullScreen ? document.body : getQueryElement(getContainer);
  var handleLoading = useCallback(function (bool) {
    setLoading(bool);
    if (typeof onLoading === 'function') {
      onLoading(bool);
    }
  }, [onLoading]);
  var handleTitleChange = useCallback(function (index) {
    setActiveTabIndex(index);
    setSearchResult({
      resultIndex: -1,
      resultCount: 0
    });
    if (typeof onTitleChange === 'function') {
      onTitleChange(index);
    }
  }, [onTitleChange]);
  var handleSearchChange = useDebounceInput(function (value) {
    var _instanceRef$current;
    searchValueRef.current = value;
    if ((_instanceRef$current = instanceRef.current) !== null && _instanceRef$current !== void 0 && (_instanceRef$current = _instanceRef$current.addons) !== null && _instanceRef$current !== void 0 && _instanceRef$current.search) {
      var _instanceRef$current$;
      (_instanceRef$current$ = instanceRef.current.addons.search()) === null || _instanceRef$current$ === void 0 || _instanceRef$current$.findNext(value, searchOptionsRef.current);
    }
  });
  var handleSearchClear = useCallback(function () {
    var _instanceRef$current2;
    if ((_instanceRef$current2 = instanceRef.current) !== null && _instanceRef$current2 !== void 0 && (_instanceRef$current2 = _instanceRef$current2.addons) !== null && _instanceRef$current2 !== void 0 && _instanceRef$current2.search) {
      var _instanceRef$current$2;
      (_instanceRef$current$2 = instanceRef.current.addons.search()) === null || _instanceRef$current$2 === void 0 || _instanceRef$current$2.findNext('', searchOptionsRef.current);
    }
  }, []);
  var handleSearchPrev = useCallback(function (value) {
    var _instanceRef$current3;
    if ((_instanceRef$current3 = instanceRef.current) !== null && _instanceRef$current3 !== void 0 && (_instanceRef$current3 = _instanceRef$current3.addons) !== null && _instanceRef$current3 !== void 0 && _instanceRef$current3.search) {
      var _instanceRef$current4;
      (_instanceRef$current4 = instanceRef.current) === null || _instanceRef$current4 === void 0 || (_instanceRef$current4 = _instanceRef$current4.addons.search()) === null || _instanceRef$current4 === void 0 || _instanceRef$current4.findPrevious(value, searchOptionsRef.current);
    }
  }, []);
  var handleSearchNext = useCallback(function (value) {
    var _instanceRef$current5;
    if ((_instanceRef$current5 = instanceRef.current) !== null && _instanceRef$current5 !== void 0 && (_instanceRef$current5 = _instanceRef$current5.addons) !== null && _instanceRef$current5 !== void 0 && _instanceRef$current5.search) {
      var _instanceRef$current$3;
      (_instanceRef$current$3 = instanceRef.current.addons.search()) === null || _instanceRef$current$3 === void 0 || _instanceRef$current$3.findNext(value, searchOptionsRef.current);
    }
  }, []);
  var handleAddonReady = useCallback(function (terminal, addon) {
    var searchAddon = addon;
    // 注意需配置 decorations 才会触发
    if (searchAddon !== null && searchAddon !== void 0 && searchAddon.onDidChangeResults) {
      searchAddon.onDidChangeResults(function (e) {
        setSearchResult(e || {
          resultIndex: -1,
          resultCount: 0
        });
      });
    }
  }, []);
  var handleScrollTop = useCallback(function () {
    var _instanceRef$current6;
    if ((_instanceRef$current6 = instanceRef.current) !== null && _instanceRef$current6 !== void 0 && _instanceRef$current6.terminal) {
      var _instanceRef$current$4;
      (_instanceRef$current$4 = instanceRef.current.terminal()) === null || _instanceRef$current$4 === void 0 || _instanceRef$current$4.scrollToTop();
    }
  }, []);
  var handleScrollBottom = useCallback(function () {
    var _instanceRef$current7;
    if ((_instanceRef$current7 = instanceRef.current) !== null && _instanceRef$current7 !== void 0 && _instanceRef$current7.terminal) {
      var _instanceRef$current$5;
      (_instanceRef$current$5 = instanceRef.current.terminal()) === null || _instanceRef$current$5 === void 0 || _instanceRef$current$5.scrollToBottom();
    }
  }, []);
  var handleFullScreen = useCallback(function () {
    setFullScreen(function (p) {
      return !p;
    });
  }, []);
  var handleRefresh = useCallback(function () {
    var _instanceRef$current8;
    if (typeof onRefresh === 'function') {
      onRefresh();
    }
    (_instanceRef$current8 = instanceRef.current) === null || _instanceRef$current8 === void 0 || _instanceRef$current8.refresh();
  }, [onRefresh]);
  useEffect(function () {
    setActiveTabIndex(activeTabIndexProp || 0);
  }, [activeTabIndexProp]);
  useImperativeHandle(ref, function () {
    return instanceRef.current;
  });
  if (virtualDomSupport) {
    globalContext.setWorkerPath(workerPath || "" || '/worker');
  }
  useEffect(function () {
    var worker = globalContext.getWorker();
    return function () {
      worker === null || worker === void 0 || worker.terminate();
      globalContext.setWorker(undefined);
    };
  }, [virtualDomSupport]);
  var render = /*#__PURE__*/React.createElement("div", {
    className: cln,
    style: style
  }, header || /*#__PURE__*/React.createElement(TerminalViewerHeader, {
    defaultValue: searchValueRef.current,
    refreshable: refreshable,
    icons: icons,
    loading: loading,
    activeTitleIndex: activeTabIndex,
    titles: titles,
    placeholder: searchPlaceholder,
    searchResult: searchResult,
    inputAddonBefore: inputAddonBefore,
    inputAddonAfter: inputAddonAfter,
    onSearchChange: handleSearchChange,
    onSearchClear: handleSearchClear,
    onSearchPrev: handleSearchPrev,
    onSearchNext: handleSearchNext,
    onTitleChange: handleTitleChange,
    onRefresh: handleRefresh
  }), Array.isArray(tabs) && tabs.map(function (tab, index) {
    if (activeTabIndex === index) {
      return /*#__PURE__*/React.createElement(ViewerBody, {
        key: tab.key || index,
        fit: fit,
        empty: empty,
        autoScroll: autoScroll,
        scrollToRow: scrollToRow,
        logAfter: logAfter,
        webLinksSupport: webLinksSupport,
        canvasSupport: canvasSupport,
        ref: instanceRef,
        defaultData: tab.defaultData,
        cacheOptions: tab.cacheOptions || cacheOptions,
        remoteOptions: tab.remoteOptions,
        highlightOptions: highlightOptions,
        terminalOptions: terminalOptions,
        extraOptions: extraOptions,
        onAddonReady: handleAddonReady,
        onLoading: handleLoading
      });
    }
    return null;
  }).filter(Boolean), !Array.isArray(tabs) && /*#__PURE__*/React.createElement(ViewerBody, {
    fit: fit,
    empty: empty,
    autoScroll: autoScroll,
    scrollToRow: scrollToRow,
    logAfter: logAfter,
    webLinksSupport: webLinksSupport,
    canvasSupport: canvasSupport,
    ref: instanceRef,
    defaultData: defaultData,
    remoteOptions: remoteOptions,
    cacheOptions: cacheOptions,
    highlightOptions: highlightOptions,
    terminalOptions: terminalOptions,
    extraOptions: extraOptions,
    onAddonReady: handleAddonReady,
    onLoading: handleLoading
  }), toolbar || /*#__PURE__*/React.createElement(TerminalViewerToolBar, {
    icons: icons,
    fullScreen: fullScreen,
    showFullScreen: showFullScreen,
    onScrollTop: handleScrollTop,
    onScrollBottom: handleScrollBottom,
    onFullScreen: handleFullScreen
  }));
  if (mountElement) {
    return /*#__PURE__*/createPortal(render, mountElement);
  }
  return render;
});
export default TerminalViewer;