import React from 'react';
import { FullscreenOutlined, FullscreenExitOutlined, VerticalAlignTopOutlined, VerticalAlignBottomOutlined } from '@ant-design/icons';
import "./index.less";
var TerminalViewerToolBar = function TerminalViewerToolBar(_ref) {
  var className = _ref.className,
    style = _ref.style,
    icons = _ref.icons,
    fullScreen = _ref.fullScreen,
    _ref$showFullScreen = _ref.showFullScreen,
    showFullScreen = _ref$showFullScreen === void 0 ? true : _ref$showFullScreen,
    onScrollTop = _ref.onScrollTop,
    onScrollBottom = _ref.onScrollBottom,
    onFullScreen = _ref.onFullScreen;
  return /*#__PURE__*/React.createElement("div", {
    className: ['terminal-viewer-toolbar', className].filter(Boolean).join(' '),
    style: style
  }, /*#__PURE__*/React.createElement("div", {
    className: "terminal-viewer-toolbar-button",
    onClick: onScrollTop
  }, (icons === null || icons === void 0 ? void 0 : icons.top) || /*#__PURE__*/React.createElement(VerticalAlignTopOutlined, {
    onPointerEnterCapture: undefined,
    onPointerLeaveCapture: undefined
  })), /*#__PURE__*/React.createElement("div", {
    className: "terminal-viewer-toolbar-button",
    onClick: onScrollBottom
  }, (icons === null || icons === void 0 ? void 0 : icons.bottom) || /*#__PURE__*/React.createElement(VerticalAlignBottomOutlined, {
    onPointerEnterCapture: undefined,
    onPointerLeaveCapture: undefined
  })), showFullScreen && /*#__PURE__*/React.createElement("div", {
    className: "terminal-viewer-toolbar-button",
    onClick: onFullScreen
  }, fullScreen ? (icons === null || icons === void 0 ? void 0 : icons.fullScreenExit) || /*#__PURE__*/React.createElement(FullscreenExitOutlined, {
    onPointerEnterCapture: undefined,
    onPointerLeaveCapture: undefined
  }) : (icons === null || icons === void 0 ? void 0 : icons.fullScreen) || /*#__PURE__*/React.createElement(FullscreenOutlined, {
    onPointerEnterCapture: undefined,
    onPointerLeaveCapture: undefined
  })));
};
export default TerminalViewerToolBar;