export function loadTest() {
  var testData = '';
  for (var i = 0; i < 100000; i += 1) {
    testData += "\u5F53\u524D\u884C\uFF1A".concat(i + 1, "\r\n");
  }
  testData += 'done...\r';
  return testData;
}
export function loadAdvancedTest() {
  var testData = '';
  testData += '[超链接] https://www.gitee.com\r\n';
  testData += '[超链接] https://www.gitee.com/**/**\r\n';
  for (var i = 0; i < 16; i += 1) {
    testData += "\x1B[48;5;".concat(i, "m ").concat(i.toString().padEnd(2, ' ').padStart(3, ' '), " \x1B[0m");
  }
  for (var _i = 0; _i < 6; _i += 1) {
    var startId = 16 + _i * 36;
    var endId = 16 + (_i + 1) * 36 - 1;
    testData += "".concat(startId.toString().padStart(3, ' '), "-").concat(endId.toString().padStart(3, ' '), " ");
    for (var j = 0; j < 36; j += 1) {
      var id = 16 + _i * 36 + j;
      testData += "\x1B[48;5;".concat(id, "m").concat((id % 10).toString().padStart(2, ' '), "\x1B[0m");
    }
    testData += '\r\n';
  }
  return testData;
}
export function loadCustomHighLightTest() {
  var random = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
  var testData = '';
  var log = function log() {
    return '应当渲染正确的颜色'.repeat(random ? Math.floor(Math.random() * 50 + 1) : 30);
  };
  testData += "[".concat(new Date().toString(), "] [SUCCESS] ").concat(log(), "\r\n");
  testData += "[".concat(new Date().toString(), "] [INFO]  ").concat(log(), "\r\n");
  testData += "[".concat(new Date().toString(), "] [info]  ").concat(log(), "\r\n");
  testData += "[".concat(new Date().toString(), "] [WARNING]  ").concat(log(), "\r\n");
  testData += "[".concat(new Date().toString(), "] [ERROR]  ").concat(log(), "\r\n");
  testData += "[".concat(new Date().toString(), "] \x1B[48;5;1m  [SUCCESS] \u5E94\u5F53\u4F18\u5148\u6E32\u67D3\u989C\u8272\u7F16\u7801  \x1B[0m");
  return testData;
}
export function fetchCustomHighLightTest() {
  var start = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
  return new Promise(function (resolve) {
    setTimeout(function () {
      var result = loadCustomHighLightTest(true);
      resolve({
        next: start > 10000 ? null : function () {
          return fetchCustomHighLightTest(start + 1000);
        },
        result: result
      });
    }, 300);
  });
}
export function remoteFetch() {
  var key = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
  var start = Number(key);
  return new Promise(function (resolve) {
    setTimeout(function () {
      var result = '';
      for (var i = start; i < start + 1000; i += 1) {
        result += "[".concat(new Date().toString(), "] \u5F53\u524D\u884C: ").concat(i, "\r\n");
      }
      resolve({
        next: start > 10000 ? null : function () {
          return remoteFetch(start + 1000);
        },
        result: result
      });
    }, 300);
  });
}
export function cacheFetch() {
  var key = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
  var start = Number(key);
  return new Promise(function (resolve) {
    setTimeout(function () {
      var result = '';
      for (var i = start; i < start + 30000; i += 1) {
        result += "[".concat(new Date().toString(), "] \u5F53\u524D\u884C: ").concat(i, "\r\n");
      }
      resolve({
        key: start,
        nextKey: start > 1000000 ? undefined : start + 30000,
        next: start > 1000000 ? undefined : function () {
          return cacheFetch(start + 30000);
        },
        result: result
      });
    }, 300);
  });
}
export default {
  loadTest: loadTest,
  remoteFetch: remoteFetch,
  cacheFetch: cacheFetch
};