import { Terminal, ITerminalAddon } from 'xterm';
export interface IHighlightOptions {
    keyword: string;
    ignoreSensitive?: boolean;
    decorations: {
        matchForegroundColor?: string;
        matchBackground?: string;
    };
}
/**
 * 基于关键字的自定义高亮插件
 */
declare class HighlightAddon implements ITerminalAddon {
    private _terminal;
    private _cacheDecorations;
    private _highlightTimeout;
    activate(terminal: Terminal): void;
    private _getLineProperty;
    private _decoration;
    private _clearDecoration;
    private _updateHighlight;
    highlight(options: IHighlightOptions[] | undefined): void;
    dispose(): void;
}
export { HighlightAddon };
export default HighlightAddon;
