import type { ISearchOptions } from '../SearchAddon';
export type SearchResultCallback = (result: SearcherResult) => void;
export type DidChangeResultsCallback = (e?: {
    resultIndex: number;
    resultCount: number;
}) => void;
export interface SearcherRef {
    findPrevious: (keyword: string, options: ISearchOptions) => void;
    findNext: (keyword: string, options: ISearchOptions) => void;
    onDidChangeResults: (callback: DidChangeResultsCallback) => void;
}
export interface SearcherResult {
    count: number;
    map: {
        [key: string | number]: string;
    };
    markedKey: number | string;
}
