export interface ICacheOptions {
    expires?: number;
}
export interface CacheItemValue {
    nextKey?: string | number;
    result: string;
    complete: boolean;
}
export type CacheItem = {
    [key: string | number]: CacheItemValue | number | undefined;
    __updateTime__?: number;
    __expiresTime__?: number;
};
declare const useCache: (itemKey: number | string | undefined, valueKey: number | string | undefined, cacheOptions?: ICacheOptions) => {
    store: LocalForage;
    setCache: (key: string | number, value: CacheItemValue) => Promise<CacheItem | null>;
    getCache: () => Promise<{
        key: undefined;
        complete: boolean;
        next: undefined;
        result: string;
    } | {
        key: string | number;
        complete: boolean;
        result: string;
        next: undefined;
    }>;
    clearCache: () => Promise<void | null>;
    destroyCache: () => Promise<void>;
};
export default useCache;
