import React from 'react';
import './index.less';
export interface TerminalViewerHeaderProps {
    /**
     * @description.zh-CN 搜索框 placeholder
     * @default 请输入
     */
    placeholder?: string;
    /**
     * @description.zh-CN  搜索框默认内容
     *
     */
    defaultValue?: string;
    /**
     * @description.zh-CN 是否支持清除搜索框
     * @default true
     */
    clearable?: string;
    /**
     * @description.zh-CN 是否支持刷新
     */
    refreshable?: boolean;
    /**
     * @description.zh-CN 是否处于加载状态
     */
    loading?: boolean;
    /**
     * @description.zh-CN 搜索结果
     */
    searchResult?: {
        resultIndex: number;
        resultCount: number;
    };
    /**
     * @description.zh-CN 激活的标题
     * @default 0;
     */
    activeTitleIndex?: number;
    /**
     * @description.zh-CN Tab 标题
     */
    titles?: React.ReactNode[] | number[];
    /**
     * @description.zh-CN 搜索框前的内容
     */
    inputAddonBefore?: React.ReactNode;
    /**
     * @description.zh-CN 搜索框后的内容
     */
    inputAddonAfter?: React.ReactNode;
    /**
     *@description.zh-CN 自定义图标
     */
    icons?: {
        search?: React.ReactNode;
        up?: React.ReactNode;
        down?: React.ReactNode;
        clear?: React.ReactNode;
        refresh?: React.ReactNode;
        loading?: React.ReactNode;
    };
    /**
     * @description.zh-CN 点击下一个按钮回调
     */
    onSearchPrev?: (value: string) => void;
    /**
     * @description.zh-CN 点击上一个按钮回调
     */
    onSearchNext?: (value: string) => void;
    /**
     * @description.zh-CN 搜索框文本变更回调函数
     */
    onSearchChange?: (e: React.ChangeEvent<HTMLInputElement>) => void;
    /**
     * @description.zh-CN 清空文本框后回调函数
     */
    onSearchClear?: (e: React.SyntheticEvent<HTMLElement>) => void;
    /**
     * @description.zh-CN 点击 Tab 标题后回调函数
     */
    onTitleChange?: (index: number) => void;
    /**
     *@description.zh-CN 点击刷新按钮后的回调
     */
    onRefresh?: (e: React.SyntheticEvent<HTMLSpanElement>) => void;
}
declare const TerminalViewerHeader: React.FC<TerminalViewerHeaderProps>;
export default TerminalViewerHeader;
