import React from 'react';
import './index.less';
interface TerminalViewerToolBarProps {
    /**
     * @description.zh-CN 外层容器样式类名
     */
    className?: string;
    /**
     * @description.zh-CN 外层容器样式
     *
     */
    style?: object;
    /**
     *@description.zh-CN 自定义图标
     */
    icons?: {
        top?: React.ReactNode;
        bottom?: React.ReactNode;
        fullScreen?: React.ReactNode;
        fullScreenExit?: React.ReactNode;
    };
    /**
     * @description.zh-CN 是否为全屏模式
     * @default false
     */
    fullScreen?: boolean;
    /**
     * @description.zh-CN 是否显示全屏图标
     * @default true
     */
    showFullScreen?: boolean;
    /** *
     * @description.zh.CN 点击滚动到顶部按钮的回调
     */
    onScrollTop?: (e: React.SyntheticEvent<HTMLDivElement>) => void;
    /**
     * @description.zh.CN 点击滚动到底部按钮的回调
     */
    onScrollBottom?: (e: React.SyntheticEvent<HTMLDivElement>) => void;
    /**
     * @description.zh.CN 点击全屏/取消全屏按钮的回调
     */
    onFullScreen?: (e: React.SyntheticEvent<HTMLDivElement>) => void;
}
declare const TerminalViewerToolBar: React.FC<TerminalViewerToolBarProps>;
export default TerminalViewerToolBar;
