import { Terminal } from 'xterm';
import { FitAddon } from 'xterm-addon-fit';
import { WebLinksAddon } from 'xterm-addon-web-links';
import { CanvasAddon } from 'xterm-addon-canvas';
import { HighlightAddon } from './Addon/HighlightAddon';
import { SearchAddon } from './Addon/SearchAddon';
import type { SearcherRef } from './Addon/WorkerLog/types';
export interface ExtraOptions {
    showLineNumber?: boolean;
}
export interface VirtualDomTerminal {
    scrollToTop: () => void;
    scrollToBottom: () => void;
}
export interface TerminalRef {
    el?: HTMLDivElement | null;
    refresh: () => void;
    addons?: {
        search?: () => SearchAddon | SearcherRef | undefined;
        fit?: () => FitAddon | undefined;
        webLinks?: () => WebLinksAddon | undefined;
        highlight?: () => HighlightAddon | undefined;
        canvas?: () => CanvasAddon | undefined;
    } | undefined;
    terminal?: () => Terminal | VirtualDomTerminal | undefined;
}
export interface LogAfterProps {
    index: number;
    content: string;
}
